#ifndef __pluged_dat
#define __pluged_dat

#include <dev/usb/usb.h>
#include <dev/usb/usbhid.h>
#include <sys/queue.h>
#include <regex.h>

#define dprint(...) if(debug) fprintf(stderr,__VA_ARGS__)

#define USBD_MAX_CMDLEN 1024
#define USBD_MAX_DESCRLEN 128

#define   USEFIELD_DEV          1
#define   USEFIELD_VENDOR_NO    2
#define   USEFIELD_PRODUCT_NO   4
#define   USEFIELD_RELEASE_NO   8
#define   USEFIELD_PRODUCT      16

struct usb_config_entry {
	unsigned int used_fields;
	/* the title of the entry in the conf */
	char descr[USBD_MAX_DESCRLEN];
	/* the device name as a regex like "umass[0-9]+" */
	char dev[USB_MAX_DEVNAMELEN];
	regex_t dev_regex;
	/* a product match pattern like ".*Nikon.*" */
	char product[USB_MAX_STRING_LEN];
	regex_t product_regex;
	/* various important ID */
	uint16_t vendor_no;
	uint16_t product_no;
	uint16_t release_no;
	/* commands executed on attach/detach */
	char attach[USBD_MAX_CMDLEN];
	char detach[USBD_MAX_CMDLEN];
	/* next element in the Linked List */
	SLIST_ENTRY(usb_config_entry) next;
};

SLIST_HEAD(usb_config_head, usb_config_entry);

/* parser */
struct usb_config_head read_config(char *filename);

#endif
